﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using IrrlichtLime;
using IrrlichtLime.Core;
using IrrlichtLime.Video;
using IrrlichtLime.Scene;
using IrrlichtLime.GUI;

namespace CapstoneProjectCSharp
{
    class EscapePoint
    {
        protected MeshSceneNode _Node;
        protected IrrlichtDevice _Device;
        protected VideoDriver _Driver;
        protected SceneManager _SceneMgr;
        protected Map _Map;
        protected string _Name;



        public MeshSceneNode SceneNode
        {
            get { return _Node; }
        }

        public EscapePoint(IrrlichtDevice device, string contentPath, Map map, string objectName)
        {
            _Map = map;
            _Name = objectName;
            _Device = device;
            _Driver = device.VideoDriver;
            _SceneMgr = device.SceneManager;

            _Node = _SceneMgr.AddCubeSceneNode(5f, _Node, 0);
            _Node.ID = 2;
            _Node.Name = _Name;

            _Node.Position = new Vector3Df(5f, 10f, -550f);
            _Node.Scale = new Vector3Df(5f, 5f, 5f);
            _Node.SetMaterialTexture(0, _Driver.GetTexture(contentPath + "invisible.png"));
            _Node.GetMaterial(0).Type = MaterialType.TransparentAlphaChannel;
            _Node.UpdateAbsolutePosition();
            _Node.DebugDataVisible = DebugSceneType.BBoxAll;
        }
    }
}
