﻿using System;
using System.Runtime.InteropServices;

namespace CapstoneProjectCSharp
{
    class Input
    {
        [DllImport("user32.dll", EntryPoint = "GetKeyboardState", SetLastError = true)]
        private static extern bool GetKeyboardState([Out] byte[] keyStates);

        [DllImport("user32.dll")]
        private static extern short GetKeyState(System.Windows.Forms.Keys nVirtKey);

        private static byte[] _Keys = new byte[256];
        private static byte[] _LastKeys = new byte[256];



        public static void UpdateState()
        {
            GetKeyState(0); // Force refresh of GetKeyboardState()
            _Keys.CopyTo(_LastKeys, 0);
            GetKeyboardState(_Keys);
        }

        public static bool IsKeyDown(System.Windows.Forms.Keys key)
        {
            return ((_Keys[(int)key] & 0x80) != 0);
        }

        public static bool IsLeftMouseClicked()
        {
            return ((GetKeyState(System.Windows.Forms.Keys.LButton) & 0x100) != 0);
        }

        public static bool WasKeyReleased(System.Windows.Forms.Keys key)
        {
            if (((_Keys[(int)key] & 0x80) == 0) && ((_LastKeys[(int)key] & 0x80) != 0))
            {
                _LastKeys[(int)key] = _Keys[(int)key];
                return true;
            }
            return false;
        }

        public static bool WasKeyPressed(System.Windows.Forms.Keys key)
        {
            if (((_Keys[(int)key] & 0x80) != 0) && ((_LastKeys[(int)key] & 0x80) == 0))
            {
                _LastKeys[(int)key] = _Keys[(int)key];
                return true;
            }
            return false;
        }
    }
}
