﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

using IrrlichtLime;
using IrrlichtLime.Core;
using IrrlichtLime.Video;
using IrrlichtLime.Scene;

namespace CapstoneProjectCSharp
{
    class Map
    {
        protected MeshSceneNode _Node;
        protected IrrlichtDevice _Device;
        protected VideoDriver _Driver;
        protected SceneManager _SceneMgr;



        public MeshSceneNode SceneNode
        {
            get { return _Node; }
            set { _Node = value; }
        }

        public Map(IrrlichtDevice device, string contentPath)
        {
            _Device = device;
            _Driver = device.VideoDriver;
            _SceneMgr = device.SceneManager;

            // Create the museum
            AnimatedMesh animMesh = _SceneMgr.GetMesh(contentPath + "Museum.obj");
            //MeshSceneNode level = smgr.AddMeshSceneNode(levelAnimMesh.GetMesh(0));
            Mesh tangentMesh = _SceneMgr.MeshManipulator.CreateMeshWithTangents(animMesh.GetMesh(0));
            _Node = _SceneMgr.AddOctreeSceneNode(tangentMesh, null, 0);
            //_Node.GetMaterial(0).SetTexture(0, _Driver.GetTexture(contentPath + "TileFloor01.png"));
            //Texture normalMap = _Driver.GetTexture(contentPath + "TileFloor01_Heightmap.png");
            //_Driver.MakeNormalMapTexture(normalMap, 5.0f);
            //_Node.GetMaterial(0).SetTexture(1, normalMap);

            //_Node.GetMaterial(1).SetTexture(0, _Driver.GetTexture(contentPath + "Wallpaper01.png"));

            /*
            _Node.GetMaterial(0).SpecularColor.Set(0u);
            _Node.GetMaterial(0).Shininess = 0f;
            _Node.GetMaterial(0).Fog = true;
            _Node.GetMaterial(0).Type = MaterialType.NormalMapSolid;
            _Node.GetMaterial(0).MaterialTypeParam = 1f / 64f;
            */

            _Node.ID = 0;
            tangentMesh.Drop();



            // Create the lighting
            //light = smgr.AddLightSceneNode(null, new Vector3Df(0, 100, 0), new Colorf(1.0f, 1.0f, 1.0f), 600.0f);
            //light.ID = ID_IsNotPickable; // Make it an invalid target for selection.
        }

        /*
        public void LoadXml(string xmlFilePath)
        {
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load(xmlFilePath);

            XmlNodeList nodes = xmlDoc.GetElementsByTagName("Waypoint");

            foreach (XmlNode node in nodes)
            {
                try
                {
                    if (node.ChildNodes.Count >= 2)
                    {
                        XmlNode PosNode = node.ChildNodes[0];
                        XmlNode RotNode = node.ChildNodes[1];

                        float posX = float.Parse(PosNode.Attributes[0].Value);
                        float posY = float.Parse(PosNode.Attributes[1].Value);
                        float posZ = float.Parse(PosNode.Attributes[2].Value);
                        Vector3Df pos = new Vector3Df(posX, posY, posZ);

                        float rotX = float.Parse(RotNode.Attributes[0].Value);
                        float rotY = float.Parse(RotNode.Attributes[1].Value);
                        float rotZ = float.Parse(RotNode.Attributes[2].Value);
                        Vector3Df rot = new Vector3Df(rotX, rotY, rotZ);

                        Waypoint wayPoint = new Waypoint(pos, rot);
                        _Waypath.Add(wayPoint);
                    }
                }
                catch
                {
                    Console.WriteLine("Failed to load map xml data!");
                    break;
                }
            }
        }

        public void SaveXml(string xmlFilePath)
        {
            using (XmlWriter xmlDoc = XmlWriter.Create(xmlFilePath))
            {
                xmlDoc.WriteStartDocument();
                xmlDoc.WriteStartElement("Waypath");

                foreach (Waypoint waypoint in _Waypath)
                {
                    xmlDoc.WriteStartElement("Waypoint");

                    xmlDoc.WriteStartElement("Position");
                    xmlDoc.WriteAttributeString("X", waypoint.Position.X.ToString());
                    xmlDoc.WriteAttributeString("Y", waypoint.Position.Y.ToString());
                    xmlDoc.WriteAttributeString("Z", waypoint.Position.Z.ToString());
                    xmlDoc.WriteEndElement();

                    xmlDoc.WriteStartElement("Rotation");
                    xmlDoc.WriteAttributeString("X", waypoint.Rotation.X.ToString());
                    xmlDoc.WriteAttributeString("Y", waypoint.Rotation.Y.ToString());
                    xmlDoc.WriteAttributeString("Z", waypoint.Rotation.Z.ToString());
                    xmlDoc.WriteEndElement();

                    xmlDoc.WriteEndElement();
                }

                xmlDoc.WriteEndDocument();
                xmlDoc.Close();
            }
        }
        */
        /////////////////////////////////////////////////////////////////////////////////////////
    }
}
