﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using IrrlichtLime;
using IrrlichtLime.Core;
using IrrlichtLime.Video;
using IrrlichtLime.Scene;
using IrrlichtLime.GUI;

namespace CapstoneProjectCSharp
{
    class StealableObject
    {
        protected MeshSceneNode _Node;
        protected IrrlichtDevice _Device;
        protected VideoDriver _Driver;
        protected SceneManager _SceneMgr;
        protected Map _Map;
        protected string _Name;



        public MeshSceneNode SceneNode
        {
            get { return _Node; }
        }

        public StealableObject(IrrlichtDevice device, string contentPath, Map map, string objectName)
        {
            _Map = map;
            _Name = objectName;
            _Device = device;
            _Driver = device.VideoDriver;
            _SceneMgr = device.SceneManager;

            AnimatedMesh animMesh = _SceneMgr.GetMesh(contentPath + objectName + ".obj");
            _Node = _SceneMgr.AddMeshSceneNode(animMesh.GetMesh(0));
            _Node.ID = 1;
            _Node.Name = _Name;
        }
    }
}
